package com.scbfkj.uni.library;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DbUtil {

    private static final Map<String, List<String>> columns = new HashMap<>();

    public static List<String> getColumns(String connection, String sql, ResultSet resultSet) throws SQLException {
        if (columns.containsKey(connection + sql)) {
            return columns.get(connection + sql);
        }
        ArrayList<String> names = new ArrayList<>();
        ResultSetMetaData metaData = resultSet.getMetaData();
        for (int i = 0; i < metaData.getColumnCount(); i++) {
            names.add(metaData.getColumnName(i + 1));
        }
        columns.put(connection + sql, names);
        return names;
    }

    public static List<Map<String, Object>> getResult(String connection, String sql, ResultSet resultSet) throws SQLException {
        List<String> cs = getColumns(connection, sql, resultSet);
        List<Map<String, Object>> result = new ArrayList<>();
        while (resultSet.next()) {
            Map<String, Object> resultMap = new HashMap<>();
            for (String name : cs) {
                Object object = resultSet.getObject(name);
                resultMap.put(name, object);
            }
            result.add(resultMap);
        }
        return result;
    }
}
