package com.scbfkj.uni.library;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

public class UniReturnUtil {

    public static Map<String, Object> success(Object data) {
        HashMap<String, Object> result = new HashMap<>();
        result.put("code", "0");
        result.put("returnData", data);

        return result;
    }

    public static Map<String, Object> success(Object data, Map<String, Object> other) {
        Map<String, Object> result = success(data);
        if (Objects.nonNull(other)) {
            result.putAll(other);
        }
        return result;
    }

    public static Map<String, Object> fail(String message, Map<String, Object> other) {
        Map<String, Object> result = fail(message);
        if (Objects.nonNull(other)) {
            result.putAll(other);
        }
        return result;
    }

    public static Map<String, Object> fail(String message) {
        HashMap<String, Object> result = new HashMap<>();
        result.put("message", message);
        result.put("code", "-1");
        return result;
    }

    public static Map<String, Object> fail(String code, String message, Map<String, Object> other) {
        Map<String, Object> result = fail(code, message);
        if (Objects.nonNull(other)) {
            result.putAll(other);
        }
        return result;
    }

    public static Map<String, Object> fail(String code, String message) {
        HashMap<String, Object> result = new HashMap<>();
        result.put("message", message);
        result.put("code", code);
        return result;
    }
}
