package com.scbfkj.uni.service;

import com.scbfkj.uni.process.DataBase;
import com.scbfkj.uni.system.Config;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Service
public class CodeCacheService {


    public void addCode(String code, String sessionId, String appid, Long securitycodeeffective, String requestIp) throws Exception {
//      使用数据库
        LocalDateTime localDateTime = LocalDateTime.now().plusSeconds(securitycodeeffective);
        String insertSql = "insert into tempsecuritycode(appid,requestip,sessionid,securitycode,expiretime) values (?,?,?,?,?)";
        DataBase.updateBatch(Config.securityConnectionStr, insertSql, new ArrayList<>() {{
            add(new Object[]{ appid, requestIp, sessionId, code, localDateTime});
        }});
        String deleteSql = "delete from tempsecuritycode where expiretime < ?";
        DataBase.updateBatch(Config.securityConnectionStr, deleteSql, new ArrayList<>() {{
            add(new Object[]{LocalDateTime.now()});
        }});
    }

    public boolean check(String code, String sessionId, String appid, String requestIp) throws Exception {

        String selectSql = "select * from tempsecuritycode where securitycode=? and sessionid=? and appid=? and requestip=?";
        List<Map<String, Object>> map = DataBase.query(Config.securityConnectionStr, selectSql, new ArrayList<>() {{
            add(new Object[]{code, sessionId, appid, requestIp});
        }});
        return !map.isEmpty();

    }

    public void remove(String code, String sessionId, String appid, String requestIp) throws Exception {
        String deleteSql = "delete from tempsecuritycode where securitycode=? and sessionid=? and appid=? and requestip=?";
        DataBase.updateBatch(Config.securityConnectionStr, deleteSql, new ArrayList<>() {{
            add(new Object[]{code, sessionId, appid, requestIp});
        }});

    }
}
