package com.scbfkj.uni.service;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.scbfkj.uni.system.LogTarget;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class LoggerService {

    private static Map<String, List<ObjectNode>> logs = new HashMap<>();




    public static void log(List<LogTarget> targetList, JsonNode data) {
        if (data instanceof ArrayNode nodes) {
            for (JsonNode node : nodes) {
                log(targetList, node);
            }
        } else if (data instanceof ObjectNode node) {
            for (LogTarget target : targetList) {
                write(target, node);
            }
        }
    }

    private static void write(LogTarget target, ObjectNode node) {
        String key = target.getType() + ";" + target.getConnection();
        if (!logs.containsKey(key)) {
            logs.put(key, List.of(node));
        } else {
            logs.get(key).add(node);
        }
    }

}
