package com.scbfkj.uni.system;

import com.scbfkj.uni.library.DataEncryptionUtil;
import com.scbfkj.uni.library.DataFormatUtil;
import jakarta.annotation.PostConstruct;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.List;


@Component
public class SystemInit {


    @Value("${db.center.config}")
    private String centerConfig;

    @Value("${db.security.config}")
    private String securityconfig;

    @Value("${app.security.enable:true}")
    private boolean enableSecurity;


    private final static String TYPE = "RSA";

    private final static String ALGORITHM = "RSA/ECB/PKCS1Padding";

    @Value("${log.target}")
    private List<String> targets;


    @PostConstruct
    public void init() throws Exception {
        Config.enable = enableSecurity;
        Config.centerConnectionStr = DataEncryptionUtil.decryptByPrivateKey(centerConfig, Config.privateKeyStr, TYPE, ALGORITHM);
        Config.securityConnectionStr = DataEncryptionUtil.decryptByPrivateKey(securityconfig, Config.privateKeyStr, TYPE, ALGORITHM);

        for (String targetStr : targets) {

            String target = DataEncryptionUtil.decryptByPrivateKey(targetStr, Config.privateKeyStr, TYPE, ALGORITHM);
            Config.logTargets.add(DataFormatUtil.stringToBean(target, LogTarget.class));

        }

    }
}
